
/*  A Bison parser, made from cfgparse.y
 by  GNU Bison version 1.25
  */

#define YYBISON 1  /* Identify Bison output.  */

#define	ARCHIVE	258
#define	COPY	259
#define	EOL	260
#define	HUP	261
#define	LOG	262
#define	RESTART	263
#define	RUN	264
#define	SET	265
#define	STOP	266
#define	EQ	267
#define	LBRACE	268
#define	RBRACE	269
#define	LABEL	270
#define	STRING	271
#define	VALUE	272
#define	VARIABLE	273
#define	NUMBER	274

#line 1 "cfgparse.y"

/* cfgparse.y -- Parse the configuration file.
   $Id: cfgparse.y,v 0.1 1998/07/04 16:57:35 eagle Exp $

   Written by Russ Allbery <rra@stanford.edu>
   Copyright 1998 by the Board of Trustees, Leland Stanford Jr. University

   Parse the configuration file.  Our end product is a linked list of log
   classes, which the rest of newsyslog will use as data to do the actual
   work (see cfgparse.h for the definitions of all of the relevant structs).
   The input stream comes from the lexer.

   Be warned:  We're pretty much relying on bison here because it makes the
   make process so much easier.  I don't think I'm doing anything
   bison-specific in this, but I'm also not testing against yacc regularly.
   So you may have to use bison. */

/***************************************************************************
* Includes and prototypes
***************************************************************************/

#include "expand.h"             /* expand() */
#include "logs.h"               /* Global struct definitions */
#include "utility.h"            /* xmalloc() */

#include <grp.h>                /* getgrnam() */
#include <pwd.h>                /* getpwnam() */
#include <stdarg.h>             /* va_list, va_start(), va_end() */
#include <stdio.h>              /* FILE, fopen(), fclose() */
#include <stdlib.h>             /* free(), exit() */
#include <string.h>             /* strcmp(), strcpy(), strlen() */

/* We want to have verbose parse error messages. */
#define YYERROR_VERBOSE 1

/* These two functions need to be externally visible. */
void cfgdie (char *format, ...);
void yyerror (char *error);
int yylex (); 

/* Stuff for internal use only. */
static struct archive *archive (char *template, int count);
static char *cfgexpand (char *string, char *name);
static char *lookup (char *path);
static void set (char *name, char *content);
static struct log *merge (struct log *logs, struct log *actions);


/***************************************************************************
* Global and external variables
***************************************************************************/
 
/* The FILE that our lexer will read from. */
extern FILE *yyin;

/* The current line of our configuration file (maintained by the lexer). */
extern int cfgline; 

/* Struct to store variable content mappings from set commands. */
struct variable {
  char *name;
  char *content;
  struct variable *next;
};

/* Stores a linked list of all variables that have been set. */
static struct variable *variables = NULL;
  
/* The final result of our parsing, a linked list of classes. */
static struct class *class;

#line 79 "cfgparse.y"
typedef union {
  char *string;
  int number;
  struct command *command;
  struct process *process;
  struct log *log;
  struct class *class;
} YYSTYPE;
#include <stdio.h>

#ifndef __cplusplus
#ifndef __STDC__
#define const
#endif
#endif



#define	YYFINAL		59
#define	YYFLAG		-32768
#define	YYNTBASE	20

#define YYTRANSLATE(x) ((unsigned)(x) <= 274 ? yytranslate[x] : 38)

static const char yytranslate[] = {     0,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     1,     2,     3,     4,     5,
     6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
    16,    17,    18,    19
};

#if YYDEBUG != 0
static const short yyprhs[] = {     0,
     0,     6,     9,    12,    13,    16,    18,    20,    24,    25,
    29,    30,    32,    34,    36,    38,    40,    49,    50,    56,
    61,    63,    65,    68,    69,    77,    80,    83,    84
};

static const short yyrhs[] = {    10,
    18,    12,    16,     5,     0,     6,    16,     0,    22,    16,
     0,     0,     9,    22,     0,    21,     0,    23,     0,    11,
    24,     5,     0,     0,     8,    24,     5,     0,     0,    19,
     0,    16,     0,    19,     0,    16,     0,    16,     0,     7,
    29,    16,    27,    28,    19,     5,    30,     0,     0,     3,
    29,    16,    19,     5,     0,     4,    29,    16,     5,     0,
    31,     0,    32,     0,    33,    34,     0,     0,    15,    13,
    25,    26,    30,    34,    14,     0,    20,    36,     0,    35,
    36,     0,     0,    36,     0
};

#endif

#if YYDEBUG != 0
static const short yyrline[] = { 0,
   103,   106,   117,   133,   145,   156,   157,   160,   161,   164,
   165,   168,   169,   184,   185,   200,   212,   238,   241,   252,
   262,   263,   266,   274,   277,   290,   291,   299,   302
};
#endif


#if YYDEBUG != 0 || defined (YYERROR_VERBOSE)

static const char * const yytname[] = {   "$","error","$undefined.","ARCHIVE",
"COPY","EOL","HUP","LOG","RESTART","RUN","SET","STOP","\"=\"","\"{\"","\"}\"",
"LABEL","STRING","VALUE","VARIABLE","NUMBER","set","hup","arguments","run","process",
"stop","restart","uid","gid","log","logs","archive","copy","action","actions",
"block","class","file", NULL
};
#endif

static const short yyr1[] = {     0,
    20,    21,    22,    22,    23,    24,    24,    25,    25,    26,
    26,    27,    27,    28,    28,    29,    30,    30,    31,    32,
    33,    33,    34,    34,    35,    36,    36,    36,    37
};

static const short yyr2[] = {     0,
     5,     2,     2,     0,     2,     1,     1,     3,     0,     3,
     0,     1,     1,     1,     1,     1,     8,     0,     5,     4,
     1,     1,     2,     0,     7,     2,     2,     0,     1
};

static const short yydefact[] = {    28,
     0,     0,    28,    28,    29,     0,     9,    26,    27,     0,
     0,    11,     0,     0,     4,     6,     7,     0,     0,    18,
     1,     2,     5,     8,     0,     0,    24,     3,    10,    16,
     0,     0,     0,    21,    22,    24,     0,     0,     0,     0,
    23,    25,    13,    12,     0,     0,     0,    15,    14,     0,
     0,    20,     0,    19,    18,    17,     0,     0,     0
};

static const short yydefgoto[] = {     3,
    16,    23,    17,    18,    12,    20,    45,    50,    31,    27,
    34,    35,    36,    37,     4,     5,    57
};

static const short yypact[] = {   -10,
   -16,     2,   -10,   -10,-32768,     4,     6,-32768,-32768,     3,
    -5,    12,    13,     7,-32768,-32768,-32768,    16,    -5,    15,
-32768,-32768,     8,-32768,    20,    11,     5,-32768,-32768,-32768,
    14,    11,    11,-32768,-32768,     5,    17,   -13,    18,    19,
-32768,-32768,-32768,-32768,    -9,     9,    21,-32768,-32768,    22,
    24,-32768,    27,-32768,    15,-32768,    33,    36,-32768
};

static const short yypgoto[] = {-32768,
-32768,-32768,-32768,    23,-32768,-32768,-32768,-32768,   -21,   -18,
-32768,-32768,-32768,    25,-32768,    10,-32768
};


#define	YYLAST		61


static const short yytable[] = {     1,
    14,     6,    43,    15,     2,    44,    48,    32,    33,    49,
    39,    40,     8,     9,     7,    10,    11,    21,    13,    19,
    24,    26,    22,    28,    29,    52,    30,    51,    54,    38,
    42,    55,    58,    46,    47,    59,    56,     0,     0,     0,
    53,    25,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    41
};

static const short yycheck[] = {    10,
     6,    18,    16,     9,    15,    19,    16,     3,     4,    19,
    32,    33,     3,     4,    13,    12,    11,     5,    16,     8,
     5,     7,    16,    16,     5,     5,    16,    19,     5,    16,
    14,     5,     0,    16,    16,     0,    55,    -1,    -1,    -1,
    19,    19,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    36
};
/* -*-C-*-  Note some compilers choke on comments on `#line' lines.  */
#line 3 "/usr/pubsw/lib/bison.simple"

/* Skeleton output parser for bison,
   Copyright (C) 1984, 1989, 1990 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

#ifndef alloca
#ifdef __GNUC__
#define alloca __builtin_alloca
#else /* not GNU C.  */
#if (!defined (__STDC__) && defined (sparc)) || defined (__sparc__) || defined (__sparc) || defined (__sgi)
#include <alloca.h>
#else /* not sparc */
#if defined (MSDOS) && !defined (__TURBOC__)
#include <malloc.h>
#else /* not MSDOS, or __TURBOC__ */
#if defined(_AIX)
#include <malloc.h>
 #pragma alloca
#else /* not MSDOS, __TURBOC__, or _AIX */
#ifdef __hpux
#ifdef __cplusplus
extern "C" {
void *alloca (unsigned int);
};
#else /* not __cplusplus */
void *alloca ();
#endif /* not __cplusplus */
#endif /* __hpux */
#endif /* not _AIX */
#endif /* not MSDOS, or __TURBOC__ */
#endif /* not sparc.  */
#endif /* not GNU C.  */
#endif /* alloca not defined.  */

/* This is the parser code that is written into each bison parser
  when the %semantic_parser declaration is not specified in the grammar.
  It was written by Richard Stallman by simplifying the hairy parser
  used when %semantic_parser is specified.  */

/* Note: there must be only one dollar sign in this file.
   It is replaced by the list of actions, each action
   as one case of the switch.  */

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		-2
#define YYEOF		0
#define YYACCEPT	return(0)
#define YYABORT 	return(1)
#define YYERROR		goto yyerrlab1
/* Like YYERROR except do call yyerror.
   This remains here temporarily to ease the
   transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */
#define YYFAIL		goto yyerrlab
#define YYRECOVERING()  (!!yyerrstatus)
#define YYBACKUP(token, value) \
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    { yychar = (token), yylval = (value);			\
      yychar1 = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { yyerror ("syntax error: cannot back up"); YYERROR; }	\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

#ifndef YYPURE
#define YYLEX		yylex()
#endif

#ifdef YYPURE
#ifdef YYLSP_NEEDED
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, &yylloc, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval, &yylloc)
#endif
#else /* not YYLSP_NEEDED */
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval)
#endif
#endif /* not YYLSP_NEEDED */
#endif

/* If nonreentrant, generate the variables here */

#ifndef YYPURE

int	yychar;			/*  the lookahead symbol		*/
YYSTYPE	yylval;			/*  the semantic value of the		*/
				/*  lookahead symbol			*/

#ifdef YYLSP_NEEDED
YYLTYPE yylloc;			/*  location data for the lookahead	*/
				/*  symbol				*/
#endif

int yynerrs;			/*  number of parse errors so far       */
#endif  /* not YYPURE */

#if YYDEBUG != 0
int yydebug;			/*  nonzero means print parse trace	*/
/* Since this is uninitialized, it does not stop multiple parsers
   from coexisting.  */
#endif

/*  YYINITDEPTH indicates the initial size of the parser's stacks	*/

#ifndef	YYINITDEPTH
#define YYINITDEPTH 200
#endif

/*  YYMAXDEPTH is the maximum size the stacks can grow to
    (effective only if the built-in stack extension method is used).  */

#if YYMAXDEPTH == 0
#undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
#define YYMAXDEPTH 10000
#endif

/* Prevent warning if -Wstrict-prototypes.  */
#ifdef __GNUC__
int yyparse (void);
#endif

#if __GNUC__ > 1		/* GNU C and GNU C++ define this.  */
#define __yy_memcpy(TO,FROM,COUNT)	__builtin_memcpy(TO,FROM,COUNT)
#else				/* not GNU C or C++ */
#ifndef __cplusplus

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (to, from, count)
     char *to;
     char *from;
     int count;
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#else /* __cplusplus */

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (char *to, char *from, int count)
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#endif
#endif

#line 196 "/usr/pubsw/lib/bison.simple"

/* The user can define YYPARSE_PARAM as the name of an argument to be passed
   into yyparse.  The argument should have type void *.
   It should actually point to an object.
   Grammar actions can access the variable by casting it
   to the proper pointer type.  */

#ifdef YYPARSE_PARAM
#ifdef __cplusplus
#define YYPARSE_PARAM_ARG void *YYPARSE_PARAM
#define YYPARSE_PARAM_DECL
#else /* not __cplusplus */
#define YYPARSE_PARAM_ARG YYPARSE_PARAM
#define YYPARSE_PARAM_DECL void *YYPARSE_PARAM;
#endif /* not __cplusplus */
#else /* not YYPARSE_PARAM */
#define YYPARSE_PARAM_ARG
#define YYPARSE_PARAM_DECL
#endif /* not YYPARSE_PARAM */

int
yyparse(YYPARSE_PARAM_ARG)
     YYPARSE_PARAM_DECL
{
  register int yystate;
  register int yyn;
  register short *yyssp;
  register YYSTYPE *yyvsp;
  int yyerrstatus;	/*  number of tokens to shift before error messages enabled */
  int yychar1 = 0;		/*  lookahead token as an internal (translated) token number */

  short	yyssa[YYINITDEPTH];	/*  the state stack			*/
  YYSTYPE yyvsa[YYINITDEPTH];	/*  the semantic value stack		*/

  short *yyss = yyssa;		/*  refer to the stacks thru separate pointers */
  YYSTYPE *yyvs = yyvsa;	/*  to allow yyoverflow to reallocate them elsewhere */

#ifdef YYLSP_NEEDED
  YYLTYPE yylsa[YYINITDEPTH];	/*  the location stack			*/
  YYLTYPE *yyls = yylsa;
  YYLTYPE *yylsp;

#define YYPOPSTACK   (yyvsp--, yyssp--, yylsp--)
#else
#define YYPOPSTACK   (yyvsp--, yyssp--)
#endif

  int yystacksize = YYINITDEPTH;

#ifdef YYPURE
  int yychar;
  YYSTYPE yylval;
  int yynerrs;
#ifdef YYLSP_NEEDED
  YYLTYPE yylloc;
#endif
#endif

  YYSTYPE yyval;		/*  the variable used to return		*/
				/*  semantic values from the action	*/
				/*  routines				*/

  int yylen;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Starting parse\n");
#endif

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss - 1;
  yyvsp = yyvs;
#ifdef YYLSP_NEEDED
  yylsp = yyls;
#endif

/* Push a new state, which is found in  yystate  .  */
/* In all cases, when you get here, the value and location stacks
   have just been pushed. so pushing a state here evens the stacks.  */
yynewstate:

  *++yyssp = yystate;

  if (yyssp >= yyss + yystacksize - 1)
    {
      /* Give user a chance to reallocate the stack */
      /* Use copies of these so that the &'s don't force the real ones into memory. */
      YYSTYPE *yyvs1 = yyvs;
      short *yyss1 = yyss;
#ifdef YYLSP_NEEDED
      YYLTYPE *yyls1 = yyls;
#endif

      /* Get the current used size of the three stacks, in elements.  */
      int size = yyssp - yyss + 1;

#ifdef yyoverflow
      /* Each stack pointer address is followed by the size of
	 the data in use in that stack, in bytes.  */
#ifdef YYLSP_NEEDED
      /* This used to be a conditional around just the two extra args,
	 but that might be undefined if yyoverflow is a macro.  */
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yyls1, size * sizeof (*yylsp),
		 &yystacksize);
#else
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yystacksize);
#endif

      yyss = yyss1; yyvs = yyvs1;
#ifdef YYLSP_NEEDED
      yyls = yyls1;
#endif
#else /* no yyoverflow */
      /* Extend the stack our own way.  */
      if (yystacksize >= YYMAXDEPTH)
	{
	  yyerror("parser stack overflow");
	  return 2;
	}
      yystacksize *= 2;
      if (yystacksize > YYMAXDEPTH)
	yystacksize = YYMAXDEPTH;
      yyss = (short *) alloca (yystacksize * sizeof (*yyssp));
      __yy_memcpy ((char *)yyss, (char *)yyss1, size * sizeof (*yyssp));
      yyvs = (YYSTYPE *) alloca (yystacksize * sizeof (*yyvsp));
      __yy_memcpy ((char *)yyvs, (char *)yyvs1, size * sizeof (*yyvsp));
#ifdef YYLSP_NEEDED
      yyls = (YYLTYPE *) alloca (yystacksize * sizeof (*yylsp));
      __yy_memcpy ((char *)yyls, (char *)yyls1, size * sizeof (*yylsp));
#endif
#endif /* no yyoverflow */

      yyssp = yyss + size - 1;
      yyvsp = yyvs + size - 1;
#ifdef YYLSP_NEEDED
      yylsp = yyls + size - 1;
#endif

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Stack size increased to %d\n", yystacksize);
#endif

      if (yyssp >= yyss + yystacksize - 1)
	YYABORT;
    }

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Entering state %d\n", yystate);
#endif

  goto yybackup;
 yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* yychar is either YYEMPTY or YYEOF
     or a valid token in external form.  */

  if (yychar == YYEMPTY)
    {
#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Reading a token: ");
#endif
      yychar = YYLEX;
    }

  /* Convert token to internal form (in yychar1) for indexing tables with */

  if (yychar <= 0)		/* This means end of input. */
    {
      yychar1 = 0;
      yychar = YYEOF;		/* Don't call YYLEX any more */

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Now at end of input.\n");
#endif
    }
  else
    {
      yychar1 = YYTRANSLATE(yychar);

#if YYDEBUG != 0
      if (yydebug)
	{
	  fprintf (stderr, "Next token is %d (%s", yychar, yytname[yychar1]);
	  /* Give the individual parser a way to print the precise meaning
	     of a token, for further debugging info.  */
#ifdef YYPRINT
	  YYPRINT (stderr, yychar, yylval);
#endif
	  fprintf (stderr, ")\n");
	}
#endif
    }

  yyn += yychar1;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != yychar1)
    goto yydefault;

  yyn = yytable[yyn];

  /* yyn is what to do for this token type in this state.
     Negative => reduce, -yyn is rule number.
     Positive => shift, yyn is new state.
       New state is final state => don't bother to shift,
       just return success.
     0, or most negative number => error.  */

  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrlab;

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting token %d (%s), ", yychar, yytname[yychar1]);
#endif

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  /* count tokens shifted since error; after three, turn off error status.  */
  if (yyerrstatus) yyerrstatus--;

  yystate = yyn;
  goto yynewstate;

/* Do the default action for the current state.  */
yydefault:

  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;

/* Do a reduction.  yyn is the number of a rule to reduce with.  */
yyreduce:
  yylen = yyr2[yyn];
  if (yylen > 0)
    yyval = yyvsp[1-yylen]; /* implement default value of the action */

#if YYDEBUG != 0
  if (yydebug)
    {
      int i;

      fprintf (stderr, "Reducing via rule %d (line %d), ",
	       yyn, yyrline[yyn]);

      /* Print the symbols being reduced, and their result.  */
      for (i = yyprhs[yyn]; yyrhs[i] > 0; i++)
	fprintf (stderr, "%s ", yytname[yyrhs[i]]);
      fprintf (stderr, " -> %s\n", yytname[yyr1[yyn]]);
    }
#endif


  switch (yyn) {

case 1:
#line 103 "cfgparse.y"
{ set (yyvsp[-3].string, yyvsp[-1].string); ;
    break;}
case 2:
#line 107 "cfgparse.y"
{
                    struct process *process;
                    
                    process = xmalloc (sizeof (struct process));
                    process->command = NULL;
                    process->pidfile = cfgexpand (yyvsp[0].string, "");
                    yyval.process = process;
                  ;
    break;}
case 3:
#line 118 "cfgparse.y"
{
                    struct command *command = yyvsp[-1].command;
                    int size;

                    /* Check to see if we need to grow our array. */
                    command->argc++;
                    if (command->argc > command->size)
                      {
                        command->size *= 2;
                        size = command->size * sizeof (char *);
                        command->argv = xrealloc (command->argv, size);
                      }
                    command->argv[command->argc - 1] = cfgexpand (yyvsp[0].string, "");
                    command->argv[command->argc] = NULL;
                  ;
    break;}
case 4:
#line 134 "cfgparse.y"
{
                    struct command *command;
                    
                    command = xmalloc (sizeof (struct command));
                    command->argc = 0;
                    command->size = 3;
                    command->argv = (char **) xmalloc (3 * sizeof (char *));
                    yyval.command = command;
                  ;
    break;}
case 5:
#line 146 "cfgparse.y"
{
                  struct process *process;
                  
                  process = xmalloc (sizeof (struct process));
                  process->command = yyvsp[0].command;
                  process->pidfile = NULL;
                  yyval.process = process;
                ;
    break;}
case 6:
#line 156 "cfgparse.y"
{ yyval.process = yyvsp[0].process; ;
    break;}
case 7:
#line 157 "cfgparse.y"
{ yyval.process = yyvsp[0].process; ;
    break;}
case 8:
#line 160 "cfgparse.y"
{ yyval.process = yyvsp[-1].process; ;
    break;}
case 9:
#line 161 "cfgparse.y"
{ yyval.process = NULL; ;
    break;}
case 10:
#line 164 "cfgparse.y"
{ yyval.process = yyvsp[-1].process; ;
    break;}
case 11:
#line 165 "cfgparse.y"
{ yyval.process = NULL; ;
    break;}
case 12:
#line 168 "cfgparse.y"
{ yyval.number = yyvsp[0].number; ;
    break;}
case 13:
#line 170 "cfgparse.y"
{
                    struct passwd *pw;

                    pw = getpwnam (yyvsp[0].string);
                    if (pw)
                      {
                        free (yyvsp[0].string);
                        yyval.number = pw->pw_uid;
                      }
                    else
                      cfgdie ("Unknown user %s", yyvsp[0].string);
                  ;
    break;}
case 14:
#line 184 "cfgparse.y"
{ yyval.number = yyvsp[0].number; ;
    break;}
case 15:
#line 186 "cfgparse.y"
{
                    struct group *gr;

                    gr = getgrnam (yyvsp[0].string);
                    if (gr)
                      {
                        free (yyvsp[0].string);
                        yyval.number = gr->gr_gid;
                      }
                    else
                      cfgdie ("Unknown group %s", yyvsp[0].string);
                  ;
    break;}
case 16:
#line 201 "cfgparse.y"
{
                    struct log *log;

                    log = xmalloc (sizeof (struct log));
                    log->name = yyvsp[0].string;
                    log->rotate = 0;
                    log->archive = NULL;
                    yyval.log = log;
                  ;
    break;}
case 17:
#line 213 "cfgparse.y"
{
                    struct log *log;
                    int mode, factor;

                    log = yyvsp[-6].log;
                    log->path = cfgexpand (lookup (yyvsp[-5].string), log->name);
                    log->tmppath = NULL;
                    log->owner = (uid_t) yyvsp[-4].number;
                    log->group = (gid_t) yyvsp[-3].number;
                    mode = yyvsp[-2].number;

                    /* Interpret the permissions as octal. */
                    factor = 1;
                    log->mode = 0;
                    while (mode > 0)
                      {
                        log->mode += (mode % 10) * factor;
                        factor *= 8;
                        mode /= 10;
                      }

                    /* Return a linked list of what we've seen so far. */
                    log->next = yyvsp[0].log;
                    yyval.log = log;
                  ;
    break;}
case 18:
#line 238 "cfgparse.y"
{ yyval.log = NULL; ;
    break;}
case 19:
#line 242 "cfgparse.y"
{
                    struct log *log;

                    log = yyvsp[-3].log;
                    log->archive = archive (yyvsp[-2].string, yyvsp[-1].number);
                    log->rotate = 1;
                    yyval.log = log;
                  ;
    break;}
case 20:
#line 253 "cfgparse.y"
{
                    struct log *log;

                    log = yyvsp[-2].log;
                    log->archive = archive (yyvsp[-1].string, -1);
                    yyval.log = log;
                  ;
    break;}
case 21:
#line 262 "cfgparse.y"
{ yyval.log = yyvsp[0].log; ;
    break;}
case 22:
#line 263 "cfgparse.y"
{ yyval.log = yyvsp[0].log; ;
    break;}
case 23:
#line 267 "cfgparse.y"
{
                    struct log *log;
                    
                    log = yyvsp[-1].log;
                    log->next = yyvsp[0].log;
                    yyval.log = log;
                  ;
    break;}
case 24:
#line 274 "cfgparse.y"
{ yyval.log = NULL; ;
    break;}
case 25:
#line 278 "cfgparse.y"
{
                    struct class *block;

                    block = xmalloc (sizeof (struct class));
                    block->name = yyvsp[-6].string;
                    block->stop = yyvsp[-4].process;
                    block->restart = yyvsp[-3].process;
                    block->logs = merge (yyvsp[-2].log, yyvsp[-1].log);
                    yyval.class = block;
                  ;
    break;}
case 26:
#line 290 "cfgparse.y"
{ yyval.class = yyvsp[0].class; ;
    break;}
case 27:
#line 292 "cfgparse.y"
{
                    struct class *block;

                    block = yyvsp[-1].class;
                    block->next = yyvsp[0].class;
                    yyval.class = block;
                  ;
    break;}
case 28:
#line 299 "cfgparse.y"
{ yyval.class = NULL; ;
    break;}
case 29:
#line 302 "cfgparse.y"
{ class = yyvsp[0].class; ;
    break;}
}
   /* the action file gets copied in in place of this dollarsign */
#line 498 "/usr/pubsw/lib/bison.simple"

  yyvsp -= yylen;
  yyssp -= yylen;
#ifdef YYLSP_NEEDED
  yylsp -= yylen;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

  *++yyvsp = yyval;

#ifdef YYLSP_NEEDED
  yylsp++;
  if (yylen == 0)
    {
      yylsp->first_line = yylloc.first_line;
      yylsp->first_column = yylloc.first_column;
      yylsp->last_line = (yylsp-1)->last_line;
      yylsp->last_column = (yylsp-1)->last_column;
      yylsp->text = 0;
    }
  else
    {
      yylsp->last_line = (yylsp+yylen-1)->last_line;
      yylsp->last_column = (yylsp+yylen-1)->last_column;
    }
#endif

  /* Now "shift" the result of the reduction.
     Determine what state that goes to,
     based on the state we popped back to
     and the rule number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTBASE] + *yyssp;
  if (yystate >= 0 && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTBASE];

  goto yynewstate;

yyerrlab:   /* here on detecting error */

  if (! yyerrstatus)
    /* If not already recovering from an error, report this error.  */
    {
      ++yynerrs;

#ifdef YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (yyn > YYFLAG && yyn < YYLAST)
	{
	  int size = 0;
	  char *msg;
	  int x, count;

	  count = 0;
	  /* Start X at -yyn if nec to avoid negative indexes in yycheck.  */
	  for (x = (yyn < 0 ? -yyn : 0);
	       x < (sizeof(yytname) / sizeof(char *)); x++)
	    if (yycheck[x + yyn] == x)
	      size += strlen(yytname[x]) + 15, count++;
	  msg = (char *) malloc(size + 15);
	  if (msg != 0)
	    {
	      strcpy(msg, "parse error");

	      if (count < 5)
		{
		  count = 0;
		  for (x = (yyn < 0 ? -yyn : 0);
		       x < (sizeof(yytname) / sizeof(char *)); x++)
		    if (yycheck[x + yyn] == x)
		      {
			strcat(msg, count == 0 ? ", expecting `" : " or `");
			strcat(msg, yytname[x]);
			strcat(msg, "'");
			count++;
		      }
		}
	      yyerror(msg);
	      free(msg);
	    }
	  else
	    yyerror ("parse error; also virtual memory exceeded");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror("parse error");
    }

  goto yyerrlab1;
yyerrlab1:   /* here on error raised explicitly by an action */

  if (yyerrstatus == 3)
    {
      /* if just tried and failed to reuse lookahead token after an error, discard it.  */

      /* return failure if at end of input */
      if (yychar == YYEOF)
	YYABORT;

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Discarding token %d (%s).\n", yychar, yytname[yychar1]);
#endif

      yychar = YYEMPTY;
    }

  /* Else will try to reuse lookahead token
     after shifting the error token.  */

  yyerrstatus = 3;		/* Each real token shifted decrements this */

  goto yyerrhandle;

yyerrdefault:  /* current state does not do anything special for the error token. */

#if 0
  /* This is wrong; only states that explicitly want error tokens
     should shift them.  */
  yyn = yydefact[yystate];  /* If its default is to accept any token, ok.  Otherwise pop it.*/
  if (yyn) goto yydefault;
#endif

yyerrpop:   /* pop the current state because it cannot handle the error token */

  if (yyssp == yyss) YYABORT;
  yyvsp--;
  yystate = *--yyssp;
#ifdef YYLSP_NEEDED
  yylsp--;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "Error: state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

yyerrhandle:

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yyerrdefault;

  yyn += YYTERROR;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != YYTERROR)
    goto yyerrdefault;

  yyn = yytable[yyn];
  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrpop;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrpop;

  if (yyn == YYFINAL)
    YYACCEPT;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting error token, ");
#endif

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  yystate = yyn;
  goto yynewstate;
}
#line 305 "cfgparse.y"


/***************************************************************************
* Error handling
***************************************************************************/

/* yyerror() is just a simple wrapper around cfgdie(). */
void yyerror (char *error) { cfgdie (error); }


/* Prepend the current line number to the error message before dying.  This
   needs to not be a static function so that the lexer can pull it in and
   use it as well. */

void
cfgdie (char *format, ...)
{
  va_list message;

  fprintf (stderr, "config line %d: ", cfgline);
  va_start (message, format);
  vfprintf (stderr, format, message);
  va_end (message);
  fprintf (stderr, "\n");
  exit (1);
}

   
/***************************************************************************
* Variable definition and lookup
***************************************************************************/

/* We maintain a linked list of variables that have been set, which is used
   later by lookup() when it does variable expansion.  Note that we don't
   check for duplicates; this is intentional, as we want to allow people to
   redefine variables.  We add all new definitions onto the *beginning* of
   the linked list, and then any subsequent lookups will always find the
   latest definition of a variable. */

static void
set (char *name, char *content)
{
  struct variable *variable;

  /* Allocate a new struct variable and add it to the linked list. */
  variable = xmalloc (sizeof (struct variable));
  variable->name = name;
  variable->content = content;
  variable->next = NULL;
  if (variables) variable->next = variables;
  variables = variable;
}


/* Given an argument that's supposed to be a path, run it through variable
   expansion if it doesn't start with a slash.  We're taking in a malloc'd
   string that we don't want if it turns out that it maps to a variable
   value, so free our argument if we're returning something out of the
   variable linked list. */

static char *
lookup (char *path)
{
  struct variable *variable;
  char *value;
  
  if (path[0] != '/')
    {
      for (variable = variables; variable; variable = variable->next)
        if (!strcmp (variable->name, path)) break;
      if (!variable) cfgdie ("Undefined variable %s", path);
      free (path);
      value = xmalloc (strlen (variable->content) + 1);
      strcpy (value, variable->content);
      return value;
    }
  else
    return path;
}


/***************************************************************************
* String expansion
***************************************************************************/

/* Check over a string for the invalid %s escape and then pass it along to
   expand() so that % expansion can be done.  The time passed to it will be
   0 (indicating to use the current time).  Returns NULL on error.  We free
   the string passed in and return the malloc'd string that expand()
   returns. */

static char *
cfgexpand (char *string, char *name)
{
  char *p;

  /* Check for invalid % escapes. */
  for (p = string; *p; p++)
    if (*p == '%' && !(*(++p) && strchr ("%dmnDMY", *p)))
      cfgdie ("Invalid %% escape");

  /* Okay, valid format.  Send it through the real expand(). */
  p = expand (string, name, 0);
  if (!p) cfgdie ("Unable to expand string");
  free (string);
  return p;
}


/***************************************************************************
* Structure generation
***************************************************************************/

/* Construct an archive struct, given a template or variable containing a
   template and the number of old logs to save as arguments.  We allocate a
   new struct archive and return it. */

static struct archive *
archive (char *template, int count)
{
  struct archive *archive;
  char *location;
  int length;

  /* Allocate a new archive struct and initialize it with the easy stuff. */
  archive = xmalloc (sizeof (struct archive));
  archive->count = count;
  archive->path = NULL;
  archive->next = NULL;

  /* Now massage the template according to what we're going to be doing. */
  location = lookup (template);
  length = strlen (location) + 4;
  if (count > 0) length += 2;
  archive->template = xmalloc (length);
  strcpy (archive->template, location);
  if (count > 0) strcat (archive->template, ".0");
  strcat (archive->template, ".gz");
  free (location);

  /* Return the completed archive struct. */
  return archive;
}


/* When we originally generated the list of logs and the list of actions, we
   did so as two separate linked lists of logs, as it was easier to convince
   yacc/bison to cope with that.  We now need to merge those two lists back
   together.  We take two pointers to linked lists of logs; the first will
   be correct for path, owner, group, and mode, and the second will have
   archives and rotate elements filled in.  We return a single pointer to a
   linked list of logs with no duplicates that has everything merged
   together.

   We have not previously checked to see if we have any duplicate log
   definitions, so we also check this while we're at it.  We call cfgdie()
   on any errors (rather than yyerror(), which can't take variable
   arguments). */

static struct log *
merge (struct log *logs, struct log *actions)
{
  struct log *current, *log, *old;
  struct archive *last;
  
  /* First, let's scan logs and make sure that there aren't any duplicates.
     We'll do this the long (simple) way. */
  for (current = logs; current->next; current = current->next)
    for (log = current->next; log; log = log->next)
      if (!strcmp (current->name, log->name))
        cfgdie ("Duplicate log definition for %s", current->name);

  /* Now, step through the actions one at a time, merging their contents
     into logs and freeing the memory used by the actions. */
  for (current = actions; current; )
    {
      /* Find the corresponding log. */
      for (log = logs; log; log = log->next)
        if (!strcmp (log->name, current->name)) break;

      /* Make sure we actually found a log. */
      if (!log) cfgdie ("Unknown log %s", current->name);

      /* Merge the actions over. */
      if (log->archive)
        {
          for (last = log->archive; last->next; last = last->next)
            ;
          last->next = current->archive;
        }
      else
        log->archive = current->archive;
      log->rotate |= current->rotate;

      /* Free the memory used by the action log struct. */
      old = current;
      current = current->next;
      free (old->name);
      free (old);
    }

  /* Return the linked list of combined log structs. */
  return logs;
}


/***************************************************************************
* Interface
***************************************************************************/

/* This is the function that the rest of the world gets to call.  It takes
   in the name of the configuration file, and returns a pointer to a linked
   list of class structs. */

struct class *
read_config (char *filename)
{
  FILE *config;

  /* Attempt to open our configuration file. */
  config = fopen (filename, "r");
  if (!config) die ("Cannot open configuration file %s", filename);

  /* Point our lexer at the right file, and then let magic happen. */
  yyin = config;
  if (yyparse () || !class) die ("Parsing of %s failed", filename);
  fclose (config);
  return class;
}
