/* utility.h -- A small set of utility functions I've found useful. */
/* $Id: utility.h,v 0.2 1998/07/04 17:13:38 eagle Exp $ */

#ifndef __h_utility__
#define __h_utility__

/***************************************************************************
* Includes
***************************************************************************/

#include <sys/types.h>          /* size_t */

/***************************************************************************
* Prototypes
***************************************************************************/

/* Print an error message to stderr and possibly exit(). */
extern void warn (char *format, ...);
extern void die (char *format, ...);

/* Print an error message plus perror() results and possibly exit(). */
extern void syswarn (char *format, ...);
extern void sysdie (char *format, ...);

/* Allocate memory, die()ing on failure. */
extern void *xmalloc (size_t size);

/* Reallocate memory, die()ing on failure. */
extern void *xrealloc (void *p, size_t size);

/**************************************************************************/

#endif /* __h_utility__ */
